package com.engine.organization.web;

import com.engine.common.util.ParamUtil;
import com.engine.common.util.ServiceUtil;
import com.engine.organization.util.response.ReturnResult;
import com.engine.organization.wrapper.PersonnelCardWrapper;
import org.apache.commons.lang3.StringUtils;
import weaver.general.Util;
import weaver.hrm.HrmUserVarify;
import weaver.hrm.User;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.ws.rs.GET;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.MediaType;
import java.util.Map;

/**
 * @author:dxfeng
 * @createTime: 2022/10/09
 * @version: 1.0
 */
public class PersonnelCardController {
    public PersonnelCardWrapper getPersonnelCardWrapper(User user) {
        return ServiceUtil.getService(PersonnelCardWrapper.class, user);
    }

    @GET
    @Path("/getPersonnelCard")
    @Produces(MediaType.APPLICATION_JSON)
    public ReturnResult getPersonnelCard(@Context HttpServletRequest request, @Context HttpServletResponse response) {
        try {
            User user = HrmUserVarify.getUser(request, response);
            Map<String, Object> map = ParamUtil.request2Map(request);
            String id = Util.null2String(map.get("id"));
            return ReturnResult.successed(getPersonnelCardWrapper(user).getPersonnelCard(StringUtils.isBlank(id) ? null : Long.parseLong(id)));
        } catch (Exception e) {
            return ReturnResult.exceptionHandle(e);
        }
    }

    @GET
    @Path("/getIframeList")
    @Produces(MediaType.APPLICATION_JSON)
    public ReturnResult getIframeList(@Context HttpServletRequest request, @Context HttpServletResponse response) {
        try {
            User user = HrmUserVarify.getUser(request, response);
            return ReturnResult.successed(getPersonnelCardWrapper(user).getIframeList());
        } catch (Exception e) {
            return ReturnResult.exceptionHandle(e);
        }
    }
}
